//THIS FUNCTION WILL CREATE A THERMOMETER LIKE DISPLAY OF THE INPUT DATA
//
//var1: 1xn vector             --> data to be displayd
//var2: string                 --> data unit

function thermometer (data,unit)

CENTER = [0 0];
END    = max(size(data));

fignr = 1002;       // use big numbers, so normal figures won't be affected

f = figure(fignr);  // change following entries depending on the language you have Scilab installed with
delmenu(fignr,'Datei');
delmenu(fignr,'Zusatzprogramme');
delmenu(fignr,'Editieren');
delmenu(fignr,'?');
toolbar(fignr,'off');

// define display settings here
f.background        = 1;
f.figure_size       = [5 300];
f.figure_name       = 'thermometer';
f.figure_position   = [500 300];

dispcolor = 7;

// define the frame for the thermometer

x = -1;
y = floor(min(data));
w = 1;
h = ceil(max(data));


rect=[x,y,w,h];
plot2d(0,0,0,rect=rect);     
a = gca();
a.visible = "on";
a.box = "off";
a.margins = [0.1,0.4,0.1,0.1];
a.axes_visible = ["off","on","off"];
a.x_location = "middle";
a.y_location = "right";
y_label = a.y_label;
y_label.text = unit;
a.y_label.font_angle = 0;
a.y_label.position = [1.25 max(data)+2];

a.foreground                = dispcolor;
a.font_foreground           = dispcolor;
a.y_label.font_foreground   = dispcolor;



plot(CENTER(1), CENTER(2),'ro');
e = gce();
p = e.children(1);  // get the point as a handle
p.mark_style = 1;
p.mark_size = 6;

// display actual temperature

for i=1:END;
    drawlater(); 
    if data(i) == 0 then;
        rect=[-0.5,data(i),1,abs(data(i))];
        xrect(rect);
        a = gca();
        a.axes_visible = ["off","on","off"];
        e = a.children(1);
        e.background = 1;
        e.thickness = 1;
    elseif data(i) > 0;
        rect=[-0.5,data(i),1,abs(data(i))];
        xfrect(rect);
        a = gca();
        a.axes_visible = ["off","on","off"];
        e = a.children(1);
        e.foreground = 5;
        e.background = 5;
        e.thickness = 3;
    else
        rect=[-0.5,0,1,abs(data(i))];
        xfrect(rect);
        a = gca();
        a.axes_visible = ["off","on","off"];
        e = a.children(1);
        e.foreground = 2;
        e.background = 2;
        e.thickness = 3;
    end        

    drawnow();
    tstep = 100; 
    xpause(tstep*1000);  // xpause counts in microseconds, tstep is for milliseconds, thatswhy factor 1000

    if  i < END
        delete(e);
    end
end

endfunction


